﻿Type=Activity
Version=1.30
FullScreen=False
IncludeTitle=False
@EndOfDesignText@
'Activity module
Sub Process_Globals
	Dim Accelerometer As PhoneSensors
	Dim SP As SoundPool
  Dim soundID(5) As Int
End Sub

Sub Globals
  Dim mainnote,harmonic As Int
	Dim ax,ay As Float
	Dim volume,hvolume,playrate,hoffset As Float
	Dim hoffsetlabel As Label
	Dim hoffsetslider As SeekBar
	Dim hvolumelabel As Label
	Dim hvolumeslider As SeekBar
	Dim volumelabel As Label
	Dim volumeslider As SeekBar
	Dim acc As Float
	Dim accelspeedspinner As Spinner
	Dim wavespinner As Spinner
	Dim accelspeed,wavetype,harmtype As Int
	Dim harmspinner As Spinner
	Dim wavetypelabel As Label
	Dim harmwavelabel As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If FirstTime Then
		SP.Initialize(4)
		soundID(1)=SP.Load(File.DirAssets,"sine1khz.ogg")
		soundID(2)=SP.Load(File.DirAssets,"square1khz.ogg")
		soundID(3)=SP.Load(File.DirAssets,"saw1khz.ogg")
	End If
	Activity.LoadLayout("sensormyn")
	hoffsetlabel.Left=10
	hoffsetslider.Left=10
	hvolumelabel.Left=10
	hvolumeslider.Left=10
	volumelabel.Left=10
	volumeslider.Left=10
	wavetypelabel.Left=10
	accelspeedspinner.Left=10
	wavespinner.Left=10
	hoffsetlabel.Width=Activity.Width-20
	hoffsetslider.Width=Activity.Width-20
	hvolumelabel.Width=Activity.Width-20
	hvolumeslider.Width=Activity.Width-20
	volumelabel.Width=Activity.Width-20
	volumeslider.Width=Activity.Width-20
	accelspeedspinner.Width=Activity.Width-20
	wavespinner.Width=(Activity.Width-30)/2
	harmspinner.Width=wavespinner.Width
	harmspinner.Left=Activity.Width-harmspinner.Width-10
	wavetypelabel.Width=wavespinner.Width
	harmwavelabel.Width=harmspinner.Width
	harmwavelabel.Left=harmspinner.Left
	volumelabel.Top=10
	volumeslider.Top=volumelabel.Top+volumelabel.Height+5
	hvolumelabel.Top=volumeslider.Top+volumeslider.Height+10
	hvolumeslider.Top=hvolumelabel.Top+hvolumelabel.Height+5
	hoffsetlabel.Top=hvolumeslider.Top+hvolumeslider.Height+10
	hoffsetslider.Top=hoffsetlabel.Top+hoffsetlabel.Height+5
  wavetypelabel.Top=hoffsetslider.Top+hoffsetslider.Height+10
	wavespinner.Top=wavetypelabel.Top+wavetypelabel.Height+5
	harmspinner.Top=wavespinner.Top
	harmwavelabel.Top=wavetypelabel.Top
	accelspeedspinner.Top=wavespinner.Top+wavespinner.Height+10
	accelspeedspinner.Add("Fastest g-sensor speed")
	accelspeedspinner.Add("Faster g-sensor speed")
	accelspeedspinner.Add("Normal g-sensor speed")
	accelspeedspinner.Add("Slowest g-sensor speed")
	wavespinner.Add("Sine")
	wavespinner.Add("Square")
	wavespinner.Add("Sawtooth")
	harmspinner.Add("Sine")
	harmspinner.Add("Square")
	harmspinner.Add("Sawtooth")
End Sub

Sub Activity_Resume
  ax=0
  ay=0
	acc=0
	volume=0.75
	hvolume=0.5
	playrate=1
	hoffset=1
	accelspeed=2
	wavetype=0
	harmtype=0
  Accelerometer.Initialize2(Accelerometer.TYPE_ACCELEROMETER,accelspeed)
  Accelerometer.StartListening("Accelerometer")
  mainnote=SP.Play(soundID(wavetype+1),volume,volume,1,-1,playrate)
  harmonic=SP.Play(soundID(harmtype+1),hvolume,hvolume,1,-1,playrate*hoffset)
	volumeslider.Value=volume*100
	hvolumeslider.Value=hvolume*100
	hoffsetslider.Value=(hoffset*100)-50
	volumeslider_ValueChanged(volumeslider.Value,False)
	hvolumeslider_ValueChanged(hvolumeslider.Value,False)
	hoffsetslider_ValueChanged(hoffsetslider.Value,False)
	accelspeedspinner.SelectedIndex=accelspeed
	wavespinner.SelectedIndex=wavetype
End Sub

Sub Activity_Pause (UserClosed As Boolean)
  Accelerometer.StopListening
	SP.Stop(mainnote)
	SP.Stop(harmonic)
End Sub

Sub Accelerometer_SensorChanged(Values() As Float)
	ax=Values(0)
	If ax>10 Then ax=10
	If ax<-10 Then ax=-10
	ay=Values(1)
	If ay>10 Then ay=10
	If ay<-10 Then ay=-10
  acc=1-Abs(ay/10)
	SP.SetVolume(mainnote,volume*acc,volume*acc)
	SP.SetVolume(harmonic,hvolume*acc,hvolume*acc)
	acc=((ax*(-1))/10)+1
	SP.SetRate(mainnote,playrate*acc)
	SP.SetRate(harmonic,playrate*acc*hoffset)
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
  If KeyCode = 4 Then
	  Main.exiting=True
    Activity.Finish
  End If
End Sub

Sub volumeslider_ValueChanged (Value As Int, UserChanged As Boolean)
	volume=Value/100
	volumelabel.Text="Main volume: " & Value & "% of master volume"
	SP.SetVolume(mainnote,volume*acc,volume*acc)
End Sub

Sub hvolumeslider_ValueChanged (Value As Int, UserChanged As Boolean)
	hvolume=Value/100
	hvolumelabel.Text="Harmonic volume: " & Value & "% of master volume"	
	SP.SetVolume(harmonic,hvolume*acc,hvolume*acc)
End Sub

Sub hoffsetslider_ValueChanged (Value As Int, UserChanged As Boolean)
	hoffset=(Value/100)+0.5
	hoffsetlabel.Text="Harmonic offset: " & (Value-50) & "% of main frequency"	
	SP.SetRate(harmonic,playrate*acc*hoffset)
End Sub

Sub accelspeedspinner_ItemClick(Position As Int, Value As Object)
  accelspeed=Position	
  Accelerometer.StopListening
  Accelerometer.Initialize2(Accelerometer.TYPE_ACCELEROMETER,accelspeed)
  Accelerometer.StartListening("Accelerometer")
End Sub

Sub wavespinner_ItemClick(Position As Int, Value As Object)
  If Position<>wavetype Then
    Accelerometer.StopListening
    wavetype=Position	
  	SP.Stop(mainnote)
    mainnote=SP.Play(soundID(harmtype+1),volume,volume,1,-1,playrate)
    Accelerometer.StartListening("Accelerometer")
	End If
End Sub

Sub harmspinner_ItemClick(Position As Int, Value As Object)
  If Position<>harmtype Then
    Accelerometer.StopListening
    harmtype=Position	
  	SP.Stop(harmonic)
    harmonic=SP.Play(soundID(harmtype+1),hvolume,hvolume,1,-1,playrate*hoffset)
    Accelerometer.StartListening("Accelerometer")
	End If
End Sub
